SystemOrganization addCategory: #'Cache-Analysis'!

TestCase subclass: #RunTimeCacheVarAnalysisTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!RunTimeCacheVarAnalysisTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/11/2015 11:56'!
testCommandLineArgumentsSingleton

	|rtAnalysis|

	rtAnalysis := RunTimeCacheVarAnalysis new.
	(rtAnalysis runCase: (CommandLineArguments->#singleton)) inspect.! !

!RunTimeCacheVarAnalysisTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/11/2015 11:56'!
testGLMDynamicPresentationCachedPresentation

	|rtAnalysis|

	rtAnalysis := RunTimeCacheVarAnalysis new.
	(rtAnalysis runCase: (GLMDynamicPresentation -> #cachedPresentation)) inspect.! !

!RunTimeCacheVarAnalysisTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:37'!
testGLMPresentationCachedDisplayedValue

	|rtAnalysis|

	rtAnalysis := RunTimeCacheVarAnalysis new.
	(rtAnalysis runCase: (GLMPresentation -> #cachedDisplayedValue)) inspect.! !

!RunTimeCacheVarAnalysisTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/15/2015 09:23'!
testOSEnvironmentCurrent

	|rtAnalysis|

	rtAnalysis := RunTimeCacheVarAnalysis new.
	(rtAnalysis runCase: (OSEnvironment->#Current)) inspect.! !

!RunTimeCacheVarAnalysisTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:38'!
testRBNamespaceSendersCache

	|rtAnalysis|

	rtAnalysis := RunTimeCacheVarAnalysis new.
	(rtAnalysis runCase: (RBNamespace -> #sendersCache)) inspect.! !

!RunTimeCacheVarAnalysisTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:34'!
testRandomCase

	|rtAnalysis|

	rtAnalysis := RunTimeCacheVarAnalysis new.
	(rtAnalysis runCase: rtAnalysis conformantSet atRandom) inspect.! !

TestCase subclass: #VariableReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:13'!
setUp

	
	! !

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 16:20'!
tearDown
	
	DummyClass recompile. "just in case"
	DummyClass class recompile. "just in case"
	DummyClass initialize.! !

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:31'!
testClassSideIV

	|  reference  |
	reference := VariableReference new on: DummyClass forVarNamed:  'classIV'; varTrace: true. 
	self assert: reference varInClass = DummyClass class.
	self assert: reference traceType = ClassSideVarTrace.
	self assert: reference varName = 'classIV'.
	self assert: reference varSites size = 4.
	reference install.
	DummyClass initialize.
	self assert: reference ownerObjectToVarValueDict keys first = DummyClass.
	self assert: (reference ownerObjectToVarValueDict at: DummyClass) class = OrderedCollection.
	DummyClass add: 5. 
	self assert: (reference ownerObjectToVarValueDict at: DummyClass) first = 5.
	DummyClass remove: 5.
	self assert: (reference ownerObjectToVarValueDict at: DummyClass) isEmpty.
	DummyClass add: 6.
	self assert: (reference ownerObjectToVarValueDict at: DummyClass) first = 6.
	self assert: DummyClass classIV __isAVariableReferenceProxy. 
	self assert: (reference ownerObjectToVarValueDict keys) size = 1. 
	reference uninstall.
	self assert: DummyClass classIV size = 1.
	self assert: DummyClass classIV first = 6.
	reference varTrace inspect.
	"Transcript open. 
	reference __varTrace print."! !

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:33'!
testInstanceSideIV

	| aSecondInstance reference dummyClassInstance |
	reference := VariableReference new on: DummyClass forVarNamed:  'instVar'; varTrace: true. 
	self assert: reference varInClass = DummyClass.
	self assert: reference traceType = InstSideVarTrace.
	self assert: reference varName = 'instVar'.
	self assert: reference varSites size = 4.
	reference install.
	dummyClassInstance := DummyClass new.
	self assert: reference ownerObjectToVarValueDict keys first = dummyClassInstance.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) class = OrderedCollection.
	dummyClassInstance add: 5. 
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) first = 5.
	dummyClassInstance remove: 5.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) isEmpty.
	dummyClassInstance add: 6.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) first = 6.
	self assert: dummyClassInstance instVar __isAVariableReferenceProxy. 
	aSecondInstance := DummyClass new.
	self assert: (aSecondInstance instVar __isAVariableReferenceProxy) = true. "instrument multiple objects"
	aSecondInstance add: 42; add: 666; remove: 42.
	self assert: (reference ownerObjectToVarValueDict keys) size = 2. 
	self assert: (reference ownerObjectToVarValueDict at: aSecondInstance) first = 666.
	reference uninstall.
	self assert: dummyClassInstance instVar size = 1.
	self assert: dummyClassInstance instVar first = 6.
	reference varTrace inspect.
	"Transcript open. 
	reference __varTrace print."! !

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:24'!
testSharedVar

	| aSecondInstance reference dummyClassInstance |
	reference := VariableReference new on: DummyClass forVarNamed:  'sharedVar'; varTrace: true. 
	self assert: reference varInClass = DummyClass.
	self assert: reference traceType = SharedVarTrace.
	self assert: reference varName = 'sharedVar'. 
	self assert: reference varSites size = 8. "lazy inits and also on the class side"
	reference install.
	dummyClassInstance := DummyClass new.
	self assert: reference ownerObjectToVarValueDict keys first = dummyClassInstance class.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance class) class = OrderedCollection.
	dummyClassInstance add: 5. 
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance class) first = 5.
	dummyClassInstance remove: 5.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance class) isEmpty.
	dummyClassInstance add: 6.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance class) first = 6.
	self assert: dummyClassInstance sharedVar __isAVariableReferenceProxy. 
	aSecondInstance := DummyClass new. "will re-initialize shared var"
	self assert: (aSecondInstance sharedVar __isAVariableReferenceProxy) = true. "the same shared var"
	(aSecondInstance class) add: 42; add: 666; remove: 42. "the same but from the class side"
	self assert: (reference ownerObjectToVarValueDict keys) size = 1. 
	self assert: (reference ownerObjectToVarValueDict at: aSecondInstance class) first = 666.
	reference uninstall.
	self assert: dummyClassInstance sharedVar size = 1.
	self assert: dummyClassInstance sharedVar first = 666.
	reference varTrace inspect.
	"Transcript open. 
	reference __varTrace print."! !

Object subclass: #DummyClass
	instanceVariableNames: 'instVar'
	classVariableNames: 'sharedVar'
	poolDictionaries: ''
	category: 'Cache-Analysis'!

DummyClass class
	instanceVariableNames: 'classIV'!

DummyClass class
	instanceVariableNames: 'classIV'!

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:11'!
add: anItem

	classIV add: anItem.
	sharedVar add: anItem.! !

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:10'!
classIV

	^ classIV! !

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:11'!
initialize

	classIV := OrderedCollection new.
	sharedVar := OrderedCollection new.! !

DummyClass initialize!

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:12'!
remove: anItem

	classIV remove: anItem.
	sharedVar remove: anItem.! !

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:01'!
sharedVar

	^ sharedVar := OrderedCollection new ! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:36'!
add: anItem

	instVar add: anItem.
	sharedVar add: anItem.! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:01'!
initialize

	instVar := OrderedCollection new.
	sharedVar := OrderedCollection new. ! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:08'!
instVar

	^ instVar! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:35'!
remove: anItem

	instVar remove: anItem.
	sharedVar remove: anItem.! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:01'!
sharedVar

	^ sharedVar! !

Object subclass: #NaiveCacheDetector
	instanceVariableNames: ''
	classVariableNames: 'methodToCacheAssocList'
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 19:54'!
LRUCacheUsers
	"(self new LRUCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ ((LRUCache allCallsOnIn: SystemNavigation new ) collect: [:method | method methodClass -> method selector]) remove: (NaiveCacheDetector->#LRUCacheUsers); asSet ! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 19:54'!
TTLCacheUsers
	"(self new TTLCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ ((TTLCache allCallsOnIn: SystemNavigation new ) collect: [:method | method methodClass -> method selector]) remove: (NaiveCacheDetector->#TTLCacheUsers); asSet ! !

!NaiveCacheDetector methodsFor: 'automatic' stamp: 'NickPapoulias 9/8/2015 21:50'!
allAutomaticallyDetectedCaches

	^ ((self cacheNamedIVs union: self cacheNamedClassVars)
		union: (self LRUCacheUsers union: self TTLCacheUsers))
		union: (self cacheNamedTemporaries union: self autoDetectedBaseClassSingletonVars).! !

!NaiveCacheDetector methodsFor: 'full - union - intersection' stamp: 'NickPapoulias 9/8/2015 18:06'!
allCachesInTheSystem

	^ self allAutomaticallyDetectedCaches union: self allManuallyDetectedCaches.
		! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/9/2015 10:29'!
allManuallyDetectedCaches

	^ (self manualGeneralCaches union: self manualSessionCaches) union: self manualSingletonCaches! !

!NaiveCacheDetector methodsFor: 'package-analysis' stamp: 'NickPapoulias 9/16/2015 11:28'!
allPackages

	^ (ProtoObject allSubclasses collect: [ :class | class package ]) asSet
		
		! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 21:41'!
autoDetectedBaseClassSingletonVars

	|classToCacheAssocList ivName |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class | 
		class isMeta
			ifFalse: [ 
				|selector|
				(class class methodDict keys includes: #uniqueInstance) 
					ifTrue: [selector := #uniqueInstance ] 
					ifFalse: [ (class class methodDict keys includes: #default) ifTrue: [ selector := #default ] ].
				selector ifNotNil:[
					[ivName := self cacheForClass: class withValue: (class perform: selector).
					classToCacheAssocList add: class -> ivName asSymbol] on: Exception do: ["some uniqueInstance calls misbehave"].
				]
			].
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/8/2015 21:32'!
cacheForClass: aClass withValue: aValue

	aClass class instanceVariables ifNotNilDo: [ :ivs | ivs do: [ :iv | 
		(aClass instVarNamed: iv) == aValue ifTrue: [ ^ iv ]	
	]].
	aClass class classVarNames ifNotNilDo: [ :vars | vars do: [ :iv | 
		(aClass classVarNamed: iv) == aValue ifTrue: [ ^ iv ]	
	]].
	^ nil! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:36'!
cacheNamedClassVars

	| classToCacheAssocList |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class | 
		class ~= NaiveCacheDetector ifTrue: [  
			(self cachesForClassInClassVars: class)
				ifNotEmptyDo: [:caches | 
						caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]]
		]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:40'!
cacheNamedIVs

	| classToCacheAssocList |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class |
		class ~= NaiveCacheDetector ifTrue: [   
			(self cachesForClass: class) 
				ifNotEmptyDo: [:caches | 
					caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]].
		]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:41'!
cacheNamedTemporaries

	methodToCacheAssocList ifNotNil: [ ^ methodToCacheAssocList ]. "takes time to compute cache it ;) -- is not counted for detection"
	methodToCacheAssocList := OrderedCollection new.
	CompiledMethod allInstances do: [ :method | 
		method methodClass ~= NaiveCacheDetector ifTrue: [  
			(self cachesForMethod: method) 
				ifNotEmptyDo: [:caches | 
						caches do: [ :cache | methodToCacheAssocList add: method -> cache asSymbol ]].
		].
	].
	^ methodToCacheAssocList := methodToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/2/2015 17:43'!
cachesForClass: aClass

	^ aClass instanceVariables ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/2/2015 17:43'!
cachesForClassInClassVars: aClass

	^ aClass classVarNames ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/8/2015 20:26'!
cachesForMethod: aMethod

	^ aMethod tempNames ifNil: [ {  } ] ifNotNilDo: 
		[:temps | (temps select: [ :temp | temp includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'full - union - intersection' stamp: 'NickPapoulias 9/8/2015 18:11'!
intersectionOfAutoAndManualDetected

	^ self allAutomaticallyDetectedCaches intersection: self allManuallyDetectedCaches.
		! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/13/2015 16:56'!
manualGeneralCaches

	^ {ASTCache -> #default.
AbstractMethodWidget -> #MethodsIconsCache.
AbstractNautilusUI -> #ClassesIconsCache.
AbstractNautilusUI -> #GroupsIconsCache.
AbstractNautilusUI -> #PackagesIconsCache.
BitBlt -> #CachedFontColorMaps.
BitBlt -> #ColorConvertingMaps.
CairoBackendCache -> #soleInstance.
Color -> #CachedColormaps.
Color -> #MaskingMap.
FreeTypeCache -> #current.
GLMUIThemeExtraIcons -> #icons.
GradientFillStyle -> #PixelRampCache.
HelpIcons -> #Icons.
KomitClass -> #classes.
KomitMethod -> #methods.
KomitPackage -> #packages.
KomitRemote -> #icon.
Komitter -> #lastMessage.
LoadingMorphState -> #image.
LogicalFont -> #all.
MCDefinition -> #Instances.
MCGitHubRepository -> #DownloadCache.
MCMethodDefinition -> #Definitions.
MCSaveVersionDialog -> #PreviousMessages.
NECSymbols -> #cachedSymbols.
RPackageSet -> #cachePackages.
ScrollBar -> #ArrowImagesCache.
ScrollBar -> #BoxesImagesCache.
SettingDeclaration -> #ValueListCache.
SingleCodeCriticResultList -> #icons.
SugsSuggestionFactory -> #collectorForAll.
SugsSuggestionFactory -> #collectorForAssignment.
SugsSuggestionFactory -> #collectorForClassVariable.
SugsSuggestionFactory -> #collectorForClass.
SugsSuggestionFactory -> #collectorForInstancesVariable.
SugsSuggestionFactory -> #collectorForLiteral.
SugsSuggestionFactory -> #collectorForMessage.
SugsSuggestionFactory -> #collectorForMethod.
SugsSuggestionFactory -> #collectorForSourceCode.
SugsSuggestionFactory -> #collectorForTemporaryVariable.
SugsSuggestionFactory -> #collectorForUndeclaredVariable.} asSet! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/9/2015 10:27'!
manualSessionCaches

	^ {MCGitHubRepository -> #DownloadCache.
MCCacheRepository -> #default.
DiskStore -> #CurrentFS.
NOCCompletionTable -> #table.
NOCCompletionTable -> #classTable.
Locale -> #Current.
Locale -> #CurrentPlatform.
DateAndTime -> #LocalTimeZone.
FT2Handle -> #Session.
FileLocator -> #Resolver.
FileStream -> #Stdin.
FileStream -> #Stdout.
FileStream -> #TheStdioHandles.
FileStream -> #StdioFiles.
FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session .
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault} asSet! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/9/2015 10:25'!
manualSingletonCaches

	^ {ASTCache -> #default.
ActiveEvent -> #ActiveEvent.
ActiveHand -> #ActiveHand.
ActiveWorld -> #ActiveWorld.
Author -> #uniqueInstance.
BorderStyle -> #Default.
CPUWatcher -> #CurrentCPUWatcher.
CairoBackendCache -> #soleInstance.
ChangesLog -> #DefaultInstance.
Clipboard -> #Default.
CommandLineArguments -> #singleton.
CriticWorkingConfiguration -> #Current.
Display -> #Display.
EditorFindReplaceDialogWindow -> #Singleton.
EmptyLayout -> #instance.
FreeTypeCache -> #current.
FreeTypeSettings -> #current.
IdentityTransform -> #Default.
InputEventFetcher -> #Default.
KMBuffer -> #uniqueInstance.
KMPragmaKeymapBuilder -> #UniqueInstance.
KMRepository -> #Singleton.
KomitterManager -> #instance.
LayoutEmptyScope -> #instance.
LogicalFontManager -> #current.
MBConfigurationRoot -> #Current.
MCFileTreeFileUtils -> #Current.
MCRepositoryGroup -> #default.
MCServerRegistry -> #uniqueInstance.
MetacelloPlatform -> #Current.
NBExternalResourceManager -> #soleInstance.
NECController -> #uniqueInstance.
NNavNavigation -> #Instance.
NNavNavigation -> #Instance.
NativeBoost -> #Current.
NautilusMonticello -> #Default.
OSPlatform -> #Current.
PharoFilesOpener -> #Default.
ProcessSpecificVariable -> #soleInstance.
Processor -> #Processor.
RBRefactoringManager -> #Instance.
RBRefactoryChangeManager -> #Instance.
RPackageOrganizer -> #default.
RecentMessageList -> #UniqueInstance.
Sensor -> #Sensor.
Smalltalk -> #Smalltalk.
SoundTheme -> #Current.
SourceFiles -> #SourceFiles.
StartupPreferencesLoader -> #UniqueInstance.
SystemAnnouncer -> #announcer.
SystemOrganization -> #SystemOrganization.
SystemProgressMorph -> #UniqueInstance.
SystemVersion -> #Current.
Transcript -> #Transcript.
UUIDGenerator -> #Default.
Undeclared -> #Undeclared.
VTermOutputDriver -> #stderrTerminalInstance.
VTermOutputDriver -> #stdoutTerminalInstance.
World -> #World.
ZnNetworkingUtils -> #Default.} asSet! !

!NaiveCacheDetector methodsFor: 'package-analysis' stamp: 'NickPapoulias 9/16/2015 11:15'!
packageAnalysisDensityOfCaches

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToNumberOfCachesDict packageToDensityOfCachesDict|
	packageToNumberOfCachesDict := self packageAnalysisNumberOfCaches.
	packageToDensityOfCachesDict := Dictionary new.
	packageToNumberOfCachesDict keysAndValuesDo: [ :key :value | 
		packageToDensityOfCachesDict at: key put: value asFloat / key classes size 
	].
	^ packageToDensityOfCachesDict
		
		! !

!NaiveCacheDetector methodsFor: 'package-analysis' stamp: 'NickPapoulias 9/16/2015 11:33'!
packageAnalysisDensityOfCachesIncludingZero

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToDensityOfCachesDict |
	packageToDensityOfCachesDict := self packageAnalysisDensityOfCaches.
	
	self allPackages do: [ :package | 
		packageToDensityOfCachesDict at: package ifAbsentPut: [ 0 asFloat ]	
	].

	^ packageToDensityOfCachesDict
		! !

!NaiveCacheDetector methodsFor: 'package-analysis' stamp: 'NickPapoulias 9/16/2015 11:09'!
packageAnalysisNumberOfCaches

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToNumberOfCachesDict |
	packageToNumberOfCachesDict := Dictionary new.
	
	self allCachesInTheSystem do: [ :assoc | "temps or users are methods to varName" 
		|package|
		package := assoc key isClass | (assoc key class = CompiledMethod)  
			ifTrue: [ assoc key package ]  
			ifFalse: [ assoc key class package ]. "is an object -- investigate which detector did this"		
			(packageToNumberOfCachesDict keys includes: package)
				ifTrue: [ 
					packageToNumberOfCachesDict 
						at: package 
						put: (packageToNumberOfCachesDict at: package) + 1 ]
				ifFalse: [ packageToNumberOfCachesDict at: package put:  1 ]
	].

	^ packageToNumberOfCachesDict  
		
		! !

!NaiveCacheDetector methodsFor: 'package-analysis' stamp: 'NickPapoulias 9/16/2015 11:31'!
packageAnalysisNumberOfCachesIncludingZero

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToNumberOfCachesDict |
	packageToNumberOfCachesDict := self packageAnalysisNumberOfCaches.
	
	self allPackages do: [ :package | 
		packageToNumberOfCachesDict at: package ifAbsentPut: [ 0 ]	
	].

	^ packageToNumberOfCachesDict
		! !

Object subclass: #OOPSQuestions
	instanceVariableNames: 'allCachesDetected analysisSubSet analysisResults nonZeroAnalysisResults allVarInNonClassesDetected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!OOPSQuestions methodsFor: 'helpers' stamp: 'NickPapoulias 9/16/2015 10:26'!
allPackages

	^ (ProtoObject allSubclasses collect: [ :class | class package ]) asSet! !

!OOPSQuestions methodsFor: 'helpers' stamp: 'NickPapoulias 9/16/2015 11:08'!
averageAndDeviation: aCollection

	| average deviation |
	average := aCollection average asFloat.
	deviation := ((aCollection 
		detectSum: [ :each | (each - average) * (each - average) ]) 
			/ aCollection size) sqrt.
			
	^ average -> deviation! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 20:25'!
cacheProtocolCloud

	| b stats|
	
	stats := nonZeroAnalysisResults flatCollect: [ :trace | trace allProtocols ].
	
	b := RTNameCloud new.
	b addStrings: stats.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 20:02'!
cacheProtocolGraph

   | b ds stats protocolToOccurencesDict|
	protocolToOccurencesDict := Dictionary new.
	stats := nonZeroAnalysisResults flatCollect: [ :trace | trace allProtocols ].
	stats do: [ :selector | 
				protocolToOccurencesDict at: selector put: (protocolToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: protocolToOccurencesDict keys.
	ds barShape width: 10.
	ds y: [:x | protocolToOccurencesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Occurences'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/17/2015 22:50'!
cacheProtocolGraphAggregate

   | b ds stats protocolToOccurencesDict|
	protocolToOccurencesDict := Dictionary new.
	stats := (nonZeroAnalysisResults select: [:trace | trace isAggregate not]) flatCollect: [ :trace | trace allProtocols ].
	stats do: [ :selector | 
				protocolToOccurencesDict at: selector put: (protocolToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: protocolToOccurencesDict keys.
	ds barShape width: 10.
	ds y: [:x | protocolToOccurencesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Occurences'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/17/2015 22:50'!
cacheProtocolGraphSingle

   | b ds stats protocolToOccurencesDict|
	protocolToOccurencesDict := Dictionary new.
	stats := (nonZeroAnalysisResults select: [:trace | trace isAggregate not]) flatCollect: [ :trace | trace allProtocols ].
	stats do: [ :selector | 
				protocolToOccurencesDict at: selector put: (protocolToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: protocolToOccurencesDict keys.
	ds barShape width: 10.
	ds y: [:x | protocolToOccurencesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Occurences'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/17/2015 23:48'!
cacheSelectorAndProtocolsStats

	| stats singleSelectorOccurences singleProtocolOccurences aggregateSelectorOccurences aggregateProtocolOccurences |
	stats := Dictionary new.
	singleSelectorOccurences := (nonZeroAnalysisResults select: [:trace | trace isAggregate not]) flatCollect: [ :trace | trace allSelectors ].
	singleProtocolOccurences := (nonZeroAnalysisResults select: [:trace | trace isAggregate not]) flatCollect: [ :trace | trace allProtocols ].
	aggregateSelectorOccurences := (nonZeroAnalysisResults select: [:trace | trace isAggregate ]) flatCollect: [ :trace | trace allSelectors ].
	aggregateProtocolOccurences :=  (nonZeroAnalysisResults select: [:trace | trace isAggregate ]) flatCollect: [ :trace | trace allProtocols ].
	
	stats at: #singleSelectors put: singleSelectorOccurences asSet.
	stats at: #singleSelectorsSize put: (stats at: #singleSelectors) size.
	stats at: #singleSelectorsOccurencesSize put: singleSelectorOccurences size.
	stats at: #singleProtocols put: singleProtocolOccurences asSet.
	stats at: #singleProtocolsSize put: (stats at: #singleProtocols) size.
	
	stats at: #aggregateSelectors put: aggregateSelectorOccurences asSet.
	stats at: #aggregateSelectorsSize put: (stats at: #aggregateSelectors) size.
	stats at: #aggregateSelectorsOccurencesSize put: aggregateSelectorOccurences size.
	stats at: #aggregateProtocols put: aggregateProtocolOccurences asSet.
	stats at: #aggregateProtocolsSize put: (stats at: #aggregateProtocols) size.
	
	^ stats! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 19:51'!
cacheSelectorCloud

	| b stats|
	
	stats := nonZeroAnalysisResults flatCollect: [ :trace | trace allSelectors ].
	
	b := RTNameCloud new.
	b addStrings: stats.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 19:48'!
cacheSelectorGraph

	| b ds stats selectorToOccurencesDict|
	selectorToOccurencesDict := Dictionary new.
	stats := nonZeroAnalysisResults flatCollect: [ :trace | trace allSelectors ].
	stats do: [ :selector | 
				selectorToOccurencesDict at: selector put: (selectorToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: selectorToOccurencesDict keys.
	ds barShape width: 10.
	ds y: [:x | selectorToOccurencesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Occurences'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/17/2015 22:49'!
cacheSelectorGraphAggregate

	| b ds stats selectorToOccurencesDict|
	selectorToOccurencesDict := Dictionary new.
	stats := (nonZeroAnalysisResults select: [:trace | trace isAggregate ]) flatCollect: [ :trace | trace allSelectors ].
	stats do: [ :selector | 
				selectorToOccurencesDict at: selector put: (selectorToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: selectorToOccurencesDict keys.
	ds barShape width: 10.
	ds y: [:x | selectorToOccurencesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Occurences'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/17/2015 23:10'!
cacheSelectorGraphSingle

	| b ds stats selectorToOccurencesDict|
	selectorToOccurencesDict := Dictionary new.
	stats := (nonZeroAnalysisResults select: [:trace | trace isAggregate not]) flatCollect: [ :trace | trace allSelectors ].
	stats do: [ :selector | 
				selectorToOccurencesDict at: selector put: (selectorToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: selectorToOccurencesDict keys.
	ds barShape width: 10.
	ds y: [:x | selectorToOccurencesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Occurences'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/17/2015 20:47'!
cacheValueClassGraph

	| b ds stats classToTracesDict|
	classToTracesDict := Dictionary new.
	stats := nonZeroAnalysisResults collect: [ :trace | trace allValueClasses ].
	stats do: [ :classSet | 
		classSet do: [ :class | 
				classToTracesDict at: class put: (classToTracesDict at: class ifAbsentPut: [ 0 ]) + 1.
		]	
	].
	classToTracesDict inspect.
	stats inspect.
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: classToTracesDict keys.
	ds barShape width: 10.
	ds y: [:x | classToTracesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Vars'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 21:53'!
cacheValuePropertiesGraph

	| b |
	b := RTStackBarPlot new.
	b interaction popupText.
	b colorPalette colors: (Array with: Color green with: Color blue).
	b add: self usesNilOrNot	 title: 'Has nil state ?'.	
	b add: self singleOrAggregate title: 'Is aggregate ?'.
	b add: self monoOrPolyMorphic title: 'Is monomorphic ?'.
	b add: self protectedNonProtected title: 'Is protected ?'.
	"b add: { 	} title: 'Is weak ?'.
	b add: { 	} title: 'Is proper ?'."
	b addLegend: #('yes' 'no').
	b barWidth: 700 height: 70.

	b addLabelToBars: [ :assoc | ((assoc key  / b totalSum * 100) asFloat printShowingDecimalPlaces: 2), '%' ] if: [:assoc | assoc key > 5 ] color: Color white.

	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 12:55'!
detectionTypes

	| b ds nDetector stats|
	b := RTGrapher new.
	b extent: 500 @ 200.
	
	nDetector := NaiveCacheDetector new.
	stats := { 
		'Session Caches' -> nDetector manualSessionCaches size . 
		'Caching Pattern' -> (nDetector manualSingletonCaches size + nDetector autoDetectedBaseClassSingletonVars size) . 
		'General Caches' -> nDetector manualGeneralCaches size . 
		'CachedNamed Vars' -> (nDetector cacheNamedClassVars size + nDetector cacheNamedIVs size + nDetector cacheNamedTemporaries size) .
		'Cache References' -> (nDetector LRUCacheUsers size + nDetector TTLCacheUsers size) . 		
		"'Intersection' -> nDetector intersectionOfAutoAndManualDetected size .  
		'Total Unique' -> nDetector allCachesInTheSystem size"  
	} asDictionary. 
	
	ds := RTData new.
	"ds interaction highlight."
	ds points: stats keys.
	ds y: [ :key | stats at: key ].
	ds barShape 
		rectangle color: Color blue; 
		width: 50.
	ds barChartWithBarTitle: #asString rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'initialization' stamp: 'NickPapoulias 9/16/2015 18:05'!
initialize

	|rt results|

	rt := RunTimeCacheVarAnalysis new.
	results := (rt materializeResultsFromFile: 'core-plus-moose-detection-and-analysis-results') asDictionary.
	allCachesDetected := results at: #AllCachesDetected.
	allVarInNonClassesDetected := allCachesDetected select: [ :assoc | assoc key isBehavior not ]. 
	analysisSubSet := results at: #AnalysisSubSet.
	analysisResults := results at: #AnalysisResults.
	nonZeroAnalysisResults := analysisResults select: [ :trace | trace events size > 0 ].! !

!OOPSQuestions methodsFor: 'issue-tracking' stamp: 'NickPapoulias 9/15/2015 18:40'!
issueTracking

	| b myClasses lb normalizer |
myClasses := (Array with: Dictionary with: Collection with: Set with: OrderedCollection ).

b := RTPieBuilder new.
b interaction popup.
b objects: myClasses.
b slice: #numberOfMethods.
b normalizer distinctColor.	
b labelled.
b emphasize: Set by: 20.
b emphasize: Dictionary by: 20.

"Legend"
lb := RTLegendBuilder new.
lb view: b view.
lb addText: 'Distribution of number of Methods in some classes'.
normalizer := RTMultiLinearColorForIdentity new objects: myClasses.
myClasses do: [ :aClass |
	lb addColor: (normalizer rtValue: aClass) text: aClass name.
].
lb build.
b build.
b view setDefaultMenu; open.
^ b view! !

!OOPSQuestions methodsFor: 'helpers' stamp: 'NickPapoulias 9/16/2015 11:25'!
minMax: aCollection
			
	^ aCollection min -> aCollection max! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 21:40'!
monoOrPolyMorphic

	|stats mono poly|
	mono := 0.
	poly := 0.
	stats := nonZeroAnalysisResults collect: [ :trace | trace allValueClasses ].
	stats do: [ :classSet | 
		(classSet select: [:class | class ~= UndefinedObject]) size > 1
			ifTrue: [ poly := poly + 1 ]
			ifFalse: [ mono := mono + 1 ]	
	].

	^ {mono . poly}! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 14:20'!
packageDensityGraph

|b2   ds detectorStats |

detectorStats := NaiveCacheDetector new packageAnalysisDensityOfCaches.


b2 := RTGrapher new.
"b2 view: c view.
b2 extent: 200 @ 150."

ds := RTData new.
"ds interaction popup."
ds dotShape circle color: Color red.
ds points: detectorStats associations.
"ds x: [ :point | point key ]."
ds y: [ :point | point value ].
ds connectColor: Color blue.
"ds barShape rectangle color: Color lightBlue."
b2 add: ds.
"b2 axisX; axisYWithNumberOfTicks: 4.
"
b2 axisX noDecimal; title: 'Package-ID'.
b2 axisY noDecimal; title: 'Caches per Class'.
b2 build.
b2 view setDefaultMenu; open.
^ b2 view! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 13:57'!
packageDensityMinMaxAvgDeviationOfDetectedSet

	|packageToDensityOfCaches|

	packageToDensityOfCaches := NaiveCacheDetector new packageAnalysisDensityOfCaches. 

	^ (self minMax: packageToDensityOfCaches values) -> (self averageAndDeviation: packageToDensityOfCaches values) 
! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 14:02'!
packageDensityMinMaxAvgDeviationOfSystemSet

	|packageToDensityOfCaches|

	packageToDensityOfCaches := NaiveCacheDetector new packageAnalysisDensityOfCachesIncludingZero. 

	^ (self minMax: packageToDensityOfCaches values) -> (self averageAndDeviation: packageToDensityOfCaches values) 
! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 12:51'!
packageDistributionGraph

|b2   ds numberOfCachesToNumberOfPackages detectorStats |

detectorStats := NaiveCacheDetector new packageAnalysisNumberOfCaches.
numberOfCachesToNumberOfPackages := Dictionary new.

detectorStats values asSet do: [:numberOfCaches |
	numberOfCachesToNumberOfPackages	at: numberOfCaches put: (detectorStats select: [:value | value = numberOfCaches]) size.
].


b2 := RTGrapher new.
"b2 view: c view.
b2 extent: 200 @ 150."

ds := RTData new.
"ds interaction popup."
ds dotShape circle color: Color red.
ds points: numberOfCachesToNumberOfPackages associations sort.
ds x: [ :point | point key ].
ds y: [ :point | point value ].
ds connectColor: Color blue.
"ds barShape rectangle color: Color lightBlue."
b2 add: ds.
"b2 axisX; axisYWithNumberOfTicks: 4.
"
b2 axisX noDecimal; title: 'Number of Caches'.
b2 axisY noDecimal; title: 'Number of Packages'.
b2 build.
b2 view setDefaultMenu; open.
^ b2 view! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 13:04'!
packageDistributionMinMaxAvgDeviationOfDetectedSet

	|packageToNumberOfCaches|

	packageToNumberOfCaches := NaiveCacheDetector new packageAnalysisNumberOfCaches. 

	^ (self minMax: packageToNumberOfCaches values) -> (self averageAndDeviation: packageToNumberOfCaches values) 
! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 13:18'!
packageDistributionMinMaxAvgDeviationOfSystemSet

	|packageToNumberOfCaches|

	packageToNumberOfCaches := NaiveCacheDetector new packageAnalysisNumberOfCachesIncludingZero. 

	^ (self minMax: packageToNumberOfCaches values) -> (self averageAndDeviation: packageToNumberOfCaches values) 
	! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 13:24'!
packageDistributionPie

| b  lb normalizer packagesToCachesWithMoreThanTen packagesToCachesWithLessThanTen lessThanTenAcc stats lessThanTenSize detectorStats allCaches |

stats := Dictionary new.
detectorStats := NaiveCacheDetector new packageAnalysisNumberOfCaches.
allCaches := NaiveCacheDetector new allCachesInTheSystem size.
packagesToCachesWithMoreThanTen := (detectorStats associations sort: [ :a :c | a value > c value ]) select: [ :assoc | assoc value > 11 ]. 
packagesToCachesWithLessThanTen := (detectorStats associations sort: [ :a :c | a value > c value ]) select: [ :assoc | assoc value <= 11 ].
lessThanTenAcc := 0.
lessThanTenSize := packagesToCachesWithLessThanTen size. 
packagesToCachesWithLessThanTen do: [ :assoc | lessThanTenAcc := lessThanTenAcc + assoc value ].
packagesToCachesWithMoreThanTen do: [ :assoc | 
	stats at: (assoc key name , ' (' , assoc value asString ,')') put: assoc value.	
].

stats at: lessThanTenSize asString , ' Pkgs <= 11 Caches' , ' (' , lessThanTenAcc asString ,')'  put: lessThanTenAcc.
 
b := RTPieBuilder new.
b interaction popup.
b objects: stats keys.
b slice: [:x | stats at: x].
b normalizer distinctColor.	
b labelled.
"b emphasize: Set by: 20.
b emphasize: Dictionary by: 20."

"Legend"
lb := RTLegendBuilder new.
lb view: b view.
lb addText: allCaches asString , ' caches in ' , detectorStats size asString , ' packages out of ' , self allPackages size asString , ' total packages in the system.' .
normalizer := RTMultiLinearColorForIdentity new objects: stats keys.
stats keys do: [ :package |
	lb addColor: (normalizer rtValue: package) text: package.
].
lb build.
b build.
b view setDefaultMenu; open.
^ b view
	! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 13:27'!
percentageOfPackagesWithCaches

^ NaiveCacheDetector new packageAnalysisNumberOfCaches keys size / self allPackages size asFloat.! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/15/2015 18:36'!
properNonProper

	| b myClasses lb normalizer |
myClasses := (Array with: Dictionary with: Collection with: Set with: OrderedCollection ).

b := RTPieBuilder new.
b interaction popup.
b objects: myClasses.
b slice: #numberOfMethods.
b normalizer distinctColor.	
b labelled.
b emphasize: Set by: 20.
b emphasize: Dictionary by: 20.

"Legend"
lb := RTLegendBuilder new.
lb view: b view.
lb addText: 'Distribution of number of Methods in some classes'.
normalizer := RTMultiLinearColorForIdentity new objects: myClasses.
myClasses do: [ :aClass |
	lb addColor: (normalizer rtValue: aClass) text: aClass name.
].
lb build.
b build.
b view setDefaultMenu; open.
^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 21:56'!
protectedNonProtected

	|protected nonProtected|
	protected := 0.
	nonProtected := 0.
	nonZeroAnalysisResults 
		do: [ :trace | |classSet|
			classSet := trace allFromMethodClasses. 
				(classSet select: 
					[:class | (class = trace tracingClass | (class inheritsFrom: trace tracingClass)) not]) isEmpty
						ifTrue: [ protected := protected + 1 ]
						ifFalse: [ nonProtected := nonProtected + 1 ]

	
		].

	^ {protected . nonProtected}! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/15/2015 18:39'!
resetInvariant

	| b myClasses lb normalizer |
myClasses := (Array with: Dictionary with: Collection with: Set with: OrderedCollection ).

b := RTPieBuilder new.
b interaction popup.
b objects: myClasses.
b slice: #numberOfMethods.
b normalizer distinctColor.	
b labelled.
b emphasize: Set by: 20.
b emphasize: Dictionary by: 20.

"Legend"
lb := RTLegendBuilder new.
lb view: b view.
lb addText: 'Distribution of number of Methods in some classes'.
normalizer := RTMultiLinearColorForIdentity new objects: myClasses.
myClasses do: [ :aClass |
	lb addColor: (normalizer rtValue: aClass) text: aClass name.
].
lb build.
b build.
b view setDefaultMenu; open.
^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 22:01'!
singleOrAggregate

	|stats single aggregate|
	single := 0.
	aggregate := 0.
	stats := nonZeroAnalysisResults collect: [ :trace | trace allValueClasses ].

	stats do: [ :classSet | 
		(classSet select: [:class | class inheritsFrom: Collection]) isEmpty
			ifTrue: [ single := single + 1 ]
			ifFalse: [ aggregate := aggregate + 1 ]	
	].

	^ {aggregate . single}! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 18:11'!
testCoverage

	| b |
	b := RTStackBarPlot new.
	b interaction popupText.
	b colorPalette colors: (Array with: Color green with: Color blue).
	b add: { analysisSubSet size . allVarInNonClassesDetected size . allCachesDetected size - analysisSubSet size - allVarInNonClassesDetected size	} asArray title: 'Case (with caching var) Coverage in UnitTests'.	
	b add: { nonZeroAnalysisResults size . analysisSubSet size - nonZeroAnalysisResults size	} title: 'Caching var Coverage within UnitTests'.
	b addLegend: #('covered' 'not-covered (temp caches)' 'not-covered (no tests)').
	b barWidth: 700 height: 70.

	b addLabelToBars: [ :assoc | ((assoc key  / b totalSum * 100) asFloat printShowingDecimalPlaces: 2), '%' ] if: [:assoc | assoc key > 5 ] color: Color white.

	b build.
	b view setDefaultMenu; open.
	^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 18:26'!
testCoverageMiscStats

	^ { nonZeroAnalysisResults size . 
		(nonZeroAnalysisResults select: [ :trace | trace class = InstSideVarTrace ]) size.
		(nonZeroAnalysisResults select: [ :trace | trace class = ClassSideVarTrace ]) size.
		(nonZeroAnalysisResults select: [ :trace | trace class = SharedVarTrace ]) size.
	(nonZeroAnalysisResults collect: [ :trace | trace events size ]) sum. 
	(nonZeroAnalysisResults collect: [ :trace | (trace events select: [ :event | event class = ReadEvent ]) size ]) sum.
	(nonZeroAnalysisResults collect: [ :trace | (trace events select: [ :event | event class = WriteEvent ]) size ]) sum.
	(nonZeroAnalysisResults collect: [ :trace | (trace events select: [ :event | event class = MsgSendEvent ]) size ]) sum.}! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/16/2015 21:28'!
usesNilOrNot

	|stats usesNil doesNotUseNil|
	usesNil := 0.
	doesNotUseNil := 0.
	stats := nonZeroAnalysisResults collect: [ :trace | trace allValueClasses ].
	stats do: [ :classSet | 
		(classSet includes: UndefinedObject)
			ifTrue: [ usesNil := usesNil + 1 ]
			ifFalse: [ doesNotUseNil := doesNotUseNil + 1 ]	
	].

	^ {usesNil . doesNotUseNil}! !

!OOPSQuestions methodsFor: 'detection-distribution' stamp: 'NickPapoulias 9/16/2015 10:40'!
variableCategories

	| b nDetector stats  |
	b := RTDoubleBarBuilder new.
	nDetector := NaiveCacheDetector new.
	stats := Dictionary new.
	(nDetector allCachesInTheSystem select: [ :assoc | assoc key isBehavior ]) 
		do: [ :assoc | |aClass aVarName| aClass := assoc key. aVarName := assoc value.
			(aClass instanceVariables) ifNotNilDo: 
			   [:ivs | 
					(ivs includes: aVarName)
						ifTrue: [stats at: 'Instance Variables' put: (stats at: 'Instance Variables' ifAbsentPut: [0]) + 1]].
			(aClass class instanceVariables) ifNotNilDo: 
				[ :mClassIvs | 
					(mClassIvs includes: aVarName)
						ifTrue: [stats at: 'Class Variables' put: (stats at: 'Class Variables' ifAbsentPut: [0]) + 1]].
			(aClass classVarNames includes: aVarName)
				ifTrue:[stats at: 'Shared Variables' put: (stats at: 'Shared Variables' ifAbsentPut: [0]) + 1]].
			
	stats at: 'Temporary Variables' put: nDetector cacheNamedTemporaries size.
	b points: stats keys.
	b bottomValue: [:x | stats at: x] titled: 'occurences'.
	"b topValue: #numberOfVariables".
	"b axisX noTick; noLabel."
	b build.
	b view setDefaultMenu; open.
^ b view! !

!OOPSQuestions methodsFor: 'analysis-implementation' stamp: 'NickPapoulias 9/15/2015 18:38'!
weakOrStrongReferencing

	| b myClasses lb normalizer |
myClasses := (Array with: Dictionary with: Collection with: Set with: OrderedCollection ).

b := RTPieBuilder new.
b interaction popup.
b objects: myClasses.
b slice: #numberOfMethods.
b normalizer distinctColor.	
b labelled.
b emphasize: Set by: 20.
b emphasize: Dictionary by: 20.

"Legend"
lb := RTLegendBuilder new.
lb view: b view.
lb addText: 'Distribution of number of Methods in some classes'.
normalizer := RTMultiLinearColorForIdentity new objects: myClasses.
myClasses do: [ :aClass |
	lb addColor: (normalizer rtValue: aClass) text: aClass name.
].
lb build.
b build.
b view setDefaultMenu; open.
^ b view! !

!Object methodsFor: '*Cache-Analysis' stamp: 'NickPapoulias 9/10/2015 10:03'!
__isAVariableReferenceProxy

	^ false! !

Object subclass: #PlaygroundAnalysisSetNick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:34'!
browseAllAccessesTo: aVar from: aClass

	SystemNavigation default browseAllAccessesTo: aVar from: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:43'!
browseAllAccessesToClassVar: aVar from: aClass

	SystemNavigation default browseAllReferencesTo:
		(aClass classPool associationAt: aVar)! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnClassSideIV: ivName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:04'!
infoOnClassVariable: cvarName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnInstanceSideIV: ivName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExample

	PlaygroundAnalysisSetNick new browseAllAccessesToClassVar: #DownloadCache from: MCGitHubRepository.  

	(MCGitHubRepository classPool at: #DownloadCache) class.
	(MCGitHubRepository classPool at: #DownloadCache) size.
	(MCGitHubRepository classPool at: #DownloadCache) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExampleClassPool

	PlaygroundAnalysisSetNick new browseAllAccessesToClassVar: #DownloadCache from: MCGitHubRepository.  

	(MCGitHubRepository classPool at: #DownloadCache) class.
	(MCGitHubRepository classPool at: #DownloadCache) size.
	(MCGitHubRepository classPool at: #DownloadCache) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExampleInstanceSide

	|instance|

	PlaygroundAnalysisSetNick new browseAllAccessesTo: #cachedPresentation from: GLMDynamicPresentation.  
	
	instance := GLMDynamicPresentation allInstances isEmpty
						ifTrue: [ GLMDynamicPresentation new ]
						ifFalse: [ GLMDynamicPresentation allInstances anyOne ].

	(instance instVarNamed: #cachedPresentation) class.
	(instance instVarNamed: #cachedPresentation) size.
	(instance instVarNamed: #cachedPresentation) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:44'!
manuallyIDedIWSTpaperSession

	^  { FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session.
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault. }! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 20:10'!
manuallyIDedIWSTpaperSingletons

	^ {NNavNavigation -> #Instance.
NativeBoost -> #Current.
NautilusMonticello -> #Default.
OSPlatform -> #Current.
"PackageOrganizer -> #default."
PharoFilesOpener -> #Default.
"PharoTutorial -> #Instance."
ProcessSpecificVariable -> #soleInstance.
Processor -> #Processor.
RBRefactoringManager -> #Instance.
RBRefactoryChangeManager -> #Instance.
RPackageOrganizer -> #default.
RecentMessageList -> #UniqueInstance.
Sensor -> #Sensor.
"SharedValueHolder -> #instance"
Smalltalk -> #Smalltalk.
SoundTheme -> #Current.
SourceFiles -> #SourceFiles.
"Spotlight -> #Current"
StartupPreferencesLoader -> #UniqueInstance.
SystemAnnouncer -> #announcer.
SystemOrganization -> #SystemOrganization.
SystemProgressMorph -> #UniqueInstance.
SystemVersion -> #Current.
Transcript -> #Transcript.
UUIDGenerator -> #Default.
Undeclared -> #Undeclared.
"UserManager -> #default"
VTermOutputDriver -> #stderrTerminalInstance.
VTermOutputDriver -> #stdoutTerminalInstance.
World -> #World.
ZnNetworkingUtils -> #Default}! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:42'!
manuallyIDedIWSTpaperVarious

	^ { MCDefinition -> #Instances.
MCGitHubRepository -> #DownloadCache.
MCMethodDefinition -> #Definitions.
MCSaveVersionDialog -> #PreviousMessages.
NECSymbols -> #cachedSymbols.
RPackageSet -> #cachePackages.
ScrollBar -> #ArrowImagesCache.
ScrollBar -> #BoxesImagesCache.
SettingDeclaration -> #ValueListCache.
SingleCodeCriticResultList -> #icons.
SugsSuggestionFactory -> #collectorForAll.
SugsSuggestionFactory -> #collectorForAssignment.
SugsSuggestionFactory -> #collectorForClassVariable.
SugsSuggestionFactory -> #collectorForClass.
SugsSuggestionFactory -> #collectorForInstancesVariable.
SugsSuggestionFactory -> #collectorForLiteral.
SugsSuggestionFactory -> #collectorForMessage.
SugsSuggestionFactory -> #collectorForMethod.
SugsSuggestionFactory -> #collectorForSourceCode.
SugsSuggestionFactory -> #collectorForTemporaryVariable.
SugsSuggestionFactory -> #collectorForUndeclaredVariable. }! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:31'!
naiveDetectorCacheIvs

	 ^ {GLMDynamicPresentation->#(#cachedPresentation). PNGReadWriter->#(#cachedDecoderMap). Color->#(#cachedDepth #cachedBitPattern). TextContainer->#(''rectangleCache''). MetacelloCommonMCSpecLoader->#(''disablePackageCache''). FreeTypeFont->#(''widthAndKernedWidthCache'' ''cachedHeight'' ''cachedAscent'' ''cachedDescent''). RBVariableEnvironment->#(''selectorCache''). ColorForm->#(''cachedDepth'' ''cachedColormap''). SystemDictionary->#(''cachedClassNames'' ''cachedNonClassNames''). SpecDebuggerStack->#(#actionsCache). NECSymbols class->#(''cachedSymbols''). EmbeddedFreeTypeFontInstaller->#(#embeddedFileInfoCache). StackLayout->#(''cachedMinExtent'' ''cachedMinExtents''). FreeTypeFontProvider->#(#fileInfoCache). MetacelloCachingGoferResolvedReference->#(''cachedVersion''). RowLayout->#(''cachedMinExtent'' ''cachedMinExtents''). MCHttpRepository->#(#readerCache). HandMorph->#(#cacheCanvas #cachedCanvasHasHoles). MessageBrowser->#(#cachedHierarchy). NewListModel->#(#listItemsCache). GTSpotterContext->#(#cache). RBNamespace->#(''implementorsCache'' ''sendersCache''). ListModel->#(#listItemsCache). RBSentNotImplementedRule->#(#implementorsCache). MetacelloLoaderPolicy->#(''cacheRepository'' ''cacheGofer''). VSCommitBrowser class->#(#commentCache). Termcap->#(''cache''). TableLayout->#(''minExtentCache''). SeamlessFastDNUProxy->#(#cachedClassProxy). PluggableListMorph->#(#hScrollRangeCache). FileDialogWindow->#(#entryCache #entryCacheDirectory). InteractiveResolver->#(''cache''). MailAddressTokenizer->#(#cachedToken). ClassWidget->#(#cachedHierarchy). GoferSynchronize->#(''cacheReferences''). GLMDynamicPresentation2->#(#cachedPresentation). ASTCacheResetTest->#(#cache). MCRepositoryGroup->#(''useCache''). CairoFontMetricsProvider->#(#cache). Gofer->#(''packageCacheRepository'' ''resolvedReferencesCache''). ProgressBarMorph->#(#cachedWidth). MethodFinder->#(#cachedClass #cachedArgNum #cachedSelectorLists). MCCacheRepository->#(#packageCaches #cacheEnabled). RPackageSet class->#(#cacheActive #cachePackages). MetacelloClearStackCacheNotification->#(''cacheNames''). HelpBrowser->#(#helpTopicCache). CharacterSetComplement->#(''byteArrayMapCache''). AlphaImageMorph->#(#cachedForm). CairoFreetypeFontRenderer->#(#cache). MCFileTreeWriter->#(#cachedPackageFileDirectoryEntries). GLMPresentation->#(#cachedDisplayedValue). GTPlayBook class->#(#cacheDirectory). MCFileBasedRepository->#(#cache #cacheFileNames). GLMPane->#(#cachedMatchingPresentations). NewList->#(#listCache #displayListCache #iconCache). CriticBrowser->#(#cache). SingleCodeCriticResultList->#(#cache). AbstractNautilusUI->#(#cachedHierarchy). FreeTypeCacheTest->#(''cache'' ''cache1K'' ''fullCache''). SmalllintManifestChecker->#(''manifestClassCache''). CairoBackendCache->#(''cache''). MCMczReader->#(''infoCache'')}! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 14:03'!
naiveLRUUsers

	 ^ {BlockClosureTest->#testMemoizedLRUCache . GradientFillStyle class->#initPixelRampCache . LRUCacheTests->#newCache . ThemeIcons->#initializeIcons . UITheme->#createArrowImagesCache . UITheme->#createBoxImagesCache}
! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:39'!
naiveTTLUsers

	 ^ {TTLCacheTests->#newCache}! !

Object subclass: #RunTimeCacheVarAnalysis
	instanceVariableNames: 'results exceptions timestamp stdout reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/13/2015 16:19'!
aSmallConformantSet

	^ { Color->#cachedBitPattern . SystemDictionary->#cachedNonClassNames . SystemDictionary->#cachedClassNames . Color->#CachedColormaps . Color->#MaskingMap . MBConfigurationRoot->#Current . MessageBrowser->#cachedHierarchy . EmbeddedFreeTypeFontInstaller->#embeddedFileInfoCache . FileLocator->#Resolver . GLMDynamicPresentation->#cachedPresentation . GLMNoBrowser class->#uniqueInstance . SystemVersion->#Current . OSPlatform->#Current . BitBlt->#ColorConvertingMaps . BitBlt->#CachedFontColorMaps . MultiByteFileStream->#LineEndDefault . RBNamespace->#implementorsCache . RBNamespace->#sendersCache . SmalllintManifestChecker->#manifestClassCache . PNGReadWriter->#cachedDecoderMap . Color->#cachedDepth } asSet! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/13/2015 15:15'!
conformantSet

	^ (NaiveCacheDetector new allCachesInTheSystem select: [ :assoc | assoc key isBehavior ]) 
		select: [ :assoc | 
			(self excludeSet includes: assoc) not &
			(Smalltalk globals keys includes: (assoc key name asString , 'Test') asSymbol)
		]! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/13/2015 16:33'!
excludeSet

	^ { DateAndTime->#LocalTimeZone . SystemAnnouncer->#announcer . FileStream->#Stdout . MCMethodDefinition->#Definitions . AbstractNautilusUI->#ClassesIconCache . HelpIcons->#Icons}! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 19:30'!
intialize

	super initialize.! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/11/2015 13:51'!
materializeResultsFromFile: aFilename

	"eg -- each run has its own timestamp: RunTimeCacheVarAnalysis new materializeResultsFromFile: 'cache-analysis-results-2015-09-11T13:40:49.406415+02:00' or 
	
	for exceptions: 
	
	RunTimeCacheVarAnalysis new materializeResultsFromFile: 'cache-analysis-exceptions-2015-09-11T13:40:49.406415+02:00'
	
"

	^ FLMaterializer materializeFromFileNamed: aFilename.! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/13/2015 19:10'!
run! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/13/2015 19:10'!
run: aSet
	
	"[RunTimeCacheVarAnalysis new runAll] fork"
	
	| resultsFilename exceptionsFilename |
	results := OrderedCollection new.
	exceptions := OrderedCollection new.
	aSet 
		do: [ :classToIvAssoc | 		
				(self stdout << 'Case: ' << classToIvAssoc printString) lf.
				[ results add: (self runCase: classToIvAssoc) ] 
					on: Exception 
					do: [ :ex | 
							(ex isKindOf: Notification) ifTrue: [ ex resume: true ]. "compiler is throwing OCWarnings etc"
							reference ifNotNil: [ reference uninstall ]. "clean-up"
							self stdout color256: Color red.
							(self stdout << '    Failed: ' << ex description) lf.
							self stdout color256: Color green.
							exceptions add: classToIvAssoc -> ex description 
					]. 
			].

	timestamp := DateAndTime now asString.
	resultsFilename := 'cache-analysis-results-' , timestamp.
	exceptionsFilename := 'cache-analysis-exceptions-' , timestamp. 

	FLSerializer serialize: results toFileNamed: resultsFilename . 
	FLSerializer serialize: exceptions toFileNamed: exceptionsFilename.
	
	(self stdout << 'Serialized results to files: ' << resultsFilename << ' and ' << exceptionsFilename) lf.
	(self stdout << 'Bye bye ..') lf.
	
	results inspect.
	exceptions inspect.
	
	self assert: (aSet size) = (results size + exceptions size).
	
	^ results! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/15/2015 12:23'!
runAndSerializeAllResultsOn: aFilename

	| detectionAndAnalysisResults |
	detectionAndAnalysisResults := { #AllCachesDetected -> (NaiveCacheDetector new allCachesInTheSystem) . #AnalysisSubSet -> self conformantSet . #AnalysisResults -> (self run: self conformantSet) }.
	 
	FLSerializer serialize: detectionAndAnalysisResults toFileNamed: aFilename.
	detectionAndAnalysisResults inspect. ! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/11/2015 13:22'!
runCase: aClassToVarAssoc


	(self stdout << '    Instrumenting... ') lf.
	reference := VariableReference new on: aClassToVarAssoc key forVarNamed: aClassToVarAssoc value asSymbol; varTrace: true.
	reference install.
	(self stdout << '    Running... ') lf.
	(Smalltalk globals at: (aClassToVarAssoc key theNonMetaClass name , 'Test') asSymbol) buildSuiteFromAllSelectors run.
	(self stdout << '    Uninstrumenting... ') lf.
	reference uninstall.
	(self stdout << '    Succeeded with: ' << reference varTrace events size << ' events') lf.
	^ reference varTrace.! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/11/2015 11:28'!
stdout

	"Example usage:.
	out << 'normal text'.
	out lf.
	'red text' do: [ :c | out color256: Color red. out << c ].
	out lf.
	'bold text' do: [ :c | out bold. out << c ].
	out clear.
	out lf."

	(stdout isNil or: [ stdout closed ])
		ifTrue: [ stdout := VTermOutputDriver stdout ].
	stdout 
		color256: Color green.
	^ stdout! !

Object subclass: #VarEvent
	instanceVariableNames: 'ownerHash fromMethod fromReceiverClass currentValueClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #MsgSendEvent
	instanceVariableNames: 'selector argClasses returnValueClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
argClasses
	^ argClasses! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
argClasses: anObject
	argClasses := anObject! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
returnValueClass
	^ returnValueClass! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
returnValueClass: anObject
	returnValueClass := anObject! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
selector
	^ selector! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
selector: anObject
	selector := anObject! !

VarEvent subclass: #ReadEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:37'!
currentValueClass
	^ currentValueClass! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:37'!
currentValueClass: anObject
	currentValueClass := anObject! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 23:52'!
fromContext: aContext
	fromMethod := aContext method.
	fromReceiverClass := aContext receiver class.! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:38'!
fromMethod
	^ fromMethod! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 00:02'!
fromReceiverClass
	^ fromReceiverClass ! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:58'!
ownerHash
	^ ownerHash! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:58'!
ownerHash: anObject
	ownerHash := anObject! !

VarEvent subclass: #WriteEvent
	instanceVariableNames: 'newValueClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!WriteEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:42'!
newValueClass
	^ newValueClass! !

!WriteEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:42'!
newValueClass: anObject
	newValueClass := anObject! !

Object subclass: #VarSite
	instanceVariableNames: 'method node link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarSite subclass: #ReadVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!ReadVarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 16:52'!
linkFor: aMetaObject

	^ link ifNil: [link := MetaLink new 
		metaObject: aMetaObject; 
		selector: #readForOwner:;
		control: #instead;
		options: #(+ optionCompileOnLinkInstallation);
		arguments: #(object)]! !

!VarSite class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:32'!
readSitesOf: aVarName in: aMethod

	^ (aMethod variableReadNodes select: [ :node | node name = aVarName ]) collect: [ :node | ReadVarSite new on: node inside: aMethod ].! !

!VarSite class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:32'!
writeSitesOf: aVarName in: aMethod

	^ (aMethod variableWriteNodes select: [ :node | node name = aVarName ]) collect: [ :node | WriteVarSite new on: node inside: aMethod ]! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 20:30'!
instrumentFor: aMetaObject

	node link: (self linkFor: aMetaObject).! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:28'!
linkFor: aMetaObject

	self subclassResponsibility ! !

!VarSite methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 18:51'!
method
	^ method! !

!VarSite methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 18:51'!
node
	^ node! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:11'!
on: aNode inside: aMethod 

	node := aNode.
	method := aMethod.! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/11/2015 13:38'!
uninstallInstrumentation

	link ifNotNil: [ link uninstall ]! !

VarSite subclass: #WriteVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!WriteVarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 16:52'!
linkFor: aMetaObject

	^ link ifNil: [link := MetaLink new 
		metaObject: aMetaObject; 
		selector: #write:forOwner:;
		control: #instead;
		options: #(+ optionCompileOnLinkInstallation);
		arguments: #(newValue object)]! !

Object subclass: #VarTrace
	instanceVariableNames: 'reference events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #ClassSideVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #InstSideVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #SharedVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #TempVarTrace
	instanceVariableNames: 'methodOfVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 22:21'!
add: aVarEvent

	events addLast: aVarEvent.
	! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:55'!
addExecuteFrom: aContext withCurrentValueClass: aValueClass withSelector: aSelector argumentClasses: argumentClasses andReturnValueClass: returnValueClass forOwner: anObject

	(self instrumentationReceiverClasses includes: aContext receiver class) ifTrue: [ ^ self ]. "dont' trace events from within instrumentation" 

	self add: (MsgSendEvent new 
					fromContext: aContext;
					currentValueClass: aValueClass;
					selector: aSelector;
					argClasses: argumentClasses;
					returnValueClass: returnValueClass;
					ownerHash: anObject hash)! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:56'!
addReadFrom: aContext withCurrentValueClass: aValueClass forOwner: anObject

	self add: (ReadEvent new 
					fromContext: aContext;
					currentValueClass: aValueClass;
					ownerHash: anObject hash)

	! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:56'!
addWriteFrom: aContext withCurrentValueClass: aValueClass andNewValueClass: aNewValueClass forOwner: anObject

	self add: (WriteEvent new 
					fromContext: aContext;
					currentValueClass: aValueClass;
					newValueClass: aNewValueClass;
					ownerHash: anObject hash )

	! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 00:11'!
allExecuteArgClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			flatCollect: [ :event | event argClasses ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:56'!
allExecuteFromMethodClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:29'!
allExecuteFromMethods

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromMethod ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:29'!
allExecuteFromPackages

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromMethod methodClass package ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:55'!
allExecuteFromReceiverClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromReceiverClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 00:11'!
allExecuteReturnClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event returnValueClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:58'!
allFromMethodClasses

	^ (events collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:25'!
allFromMethods

	^ (events collect: [ :event | event fromMethod ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:25'!
allFromPackages

	^ (events collect: [ :event | event fromMethod methodClass package ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:59'!
allFromReceiverClasses

	^ (events collect: [ :event | event fromReceiverClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 11:01'!
allOwnersHash

	^ (events  
		collect: [ :event | event ownerHash ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/16/2015 20:00'!
allProtocols

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event |
				|protocol|
				event currentValueClass classAndMethodFor: event selector do: [ :class :method | protocol := method protocol ] ifAbsent: [  ].				 
				protocol ]).! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:30'!
allReadFromMethods

	^ ((events select: [ :event | event class = ReadEvent ]) 
			collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/16/2015 19:45'!
allSelectors

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event selector ]).! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 11:34'!
allSelectorsFromOutsideOwnersClass

	^ ((events select: [ :event | (event class = MsgSendEvent) & (event fromMethod methodClass = reference varInClass) not ]) 
			collect: [ :event | event selector ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 11:34'!
allSelectorsFromWithinOwnersClass

	^ ((events select: [ :event | (event class = MsgSendEvent) & (event fromMethod methodClass = reference varInClass) ]) 
			collect: [ :event | event selector ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:24'!
allValueClasses

	^ (events collect: [ :event | event currentValueClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:31'!
allWriteFromMethods

	^ ((events select: [ :event | event class = WriteEvent ]) 
			collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:21'!
events

	^ events! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 22:20'!
for: aReference

	reference := aReference. 
	events := OrderedCollection new.! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 00:04'!
instrumentationReceiverClasses

	^ { RBLiteralNode class . IRBytecodeGenerator . HookGenerator . OCLiteralList . OCLiteralSet . MetaLink }! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/17/2015 22:52'!
isAggregate

	^ (self allValueClasses select: [:class | class inheritsFrom: Collection]) isEmpty not! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 12:43'!
traceType

	^ self class! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 10:14'!
tracingClass
	
	^ reference varInClass! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 10:34'!
varName
	
	^ reference varName! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 10:34'!
varSites
	
	^ reference varSites! !

Object subclass: #VariableReference
	instanceVariableNames: 'class varName varSites varTrace varTraceFlag ownerObjectToVarValueDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/13/2015 13:43'!
checkPreExistingValueForOwner: anInstrumentedObject

	((self ownersStoredValue: anInstrumentedObject) __isAVariableReferenceProxy) 
		ifFalse: [  
			self ownerObjectToVarValueDict at: (self properSideOf: anInstrumentedObject) put: (self ownersStoredValue: anInstrumentedObject).
			self owner: anInstrumentedObject storeValueInVar: (VariableReferenceProxy new 
																			__instrumentedObject: anInstrumentedObject;  
																			__variableReference: self).  ].
		! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/13/2015 12:25'!
currentValueForOwner: anObject

	^ self ownerObjectToVarValueDict at: (self properSideOf: anObject) ! !

!VariableReference methodsFor: 'rwx' stamp: 'NickPapoulias 9/13/2015 13:43'!
execute: aSelector withArgs: arguments forOwner: anObject from: aProxy

	"we end-up here (receiving a message) from a reference inside/propagated from myInstrumentedObject read/writes"

	| returnValue |

	returnValue := [(self currentValueForOwner: anObject) perform: aSelector withArguments: arguments] on: Exception do: [:ex | self uninstall. ex signal].
	self traceExecuteWithSelector: aSelector arguments: arguments andReturnValue: returnValue forOwner: anObject.
	^ returnValue == (self currentValueForOwner: anObject) "this cascading effect is debatable how usefull will be"
		ifTrue: [ aProxy ]
		ifFalse: [ returnValue ] ! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 10:25'!
install

	varSites do: [ :varSite | varSite instrumentFor: self ].! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:29'!
on: aClass forClassSideVarNamed: aVarName

	"the same but for the metaclass dict"
	
	self on: aClass class forInstanceSideVarNamed: aVarName! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:29'!
on: aClass forInstanceSideVarNamed: aVarName

	varSites "now this can be done for the subclasses as well -- but this is good enough for now"
		addAll: (aClass methodDict values flatCollect: [ :method | VarSite readSitesOf: aVarName in: method  ]);
		addAll: (aClass methodDict values flatCollect: [ :method | VarSite writeSitesOf: aVarName in: method  ]).! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:30'!
on: aClass forSharedVarNamed: aVarName

	"can be accessed by both instance side and class side"

	self on: aClass forInstanceSideVarNamed: aVarName.
	self on: aClass forClassSideVarNamed: aVarName.! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:41'!
on: aClass forVarNamed: aVarName

	"determine where the var belongs and call the right on:for: method"
	
	varTraceFlag := false.
	varName := aVarName.
	class := aClass.
	ownerObjectToVarValueDict := Dictionary new.
	varSites := OrderedCollection new.
	
	(aClass instanceVariables includes: aVarName)
		ifTrue: [ varTrace := InstSideVarTrace new for: self . ^ self on: aClass forInstanceSideVarNamed: aVarName ].
	aClass class instanceVariables ifNotNilDo: [ :mClassIvs | 
		(mClassIvs includes: aVarName)
			ifTrue: [ class := aClass class. varTrace := ClassSideVarTrace new for: self . ^ self on: aClass forClassSideVarNamed: aVarName ]].
	(aClass classVarNames includes: aVarName)
		ifTrue: [ varTrace := SharedVarTrace new for: self . ^ self on: aClass forSharedVarNamed: aVarName ].
	self error: 'No such varName in instance, class or shared'
	
	! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:15'!
owner: anOwner storeValueInVar: aValue

	^ self traceType = SharedVarTrace 
		ifTrue: [ (self properSideOf: anOwner) classVarNamed: varName put: aValue ]
		ifFalse: [ anOwner instVarNamed: varName put: aValue ]! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/13/2015 12:25'!
ownerObjectToVarValueDict
	^ ownerObjectToVarValueDict ifNil: [ ownerObjectToVarValueDict := Dictionary new ]! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:15'!
ownersStoredValue: anOwner

	^ self traceType = SharedVarTrace 
		ifTrue: [ (self properSideOf: anOwner) classVarNamed: varName ]
		ifFalse: [ anOwner instVarNamed: varName ] ! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:11'!
properSideOf: anOwner

	^ self traceType = SharedVarTrace 
				ifTrue: [ anOwner isBehavior ifTrue: [ anOwner ] ifFalse: [ anOwner class ] ]
				ifFalse: [ anOwner ]. 
	! !

!VariableReference methodsFor: 'rwx' stamp: 'NickPapoulias 9/10/2015 12:56'!
readForOwner: anObject

	self checkPreExistingValueForOwner: anObject; traceReadForOwner: anObject. 
	^ self ownersStoredValue: anObject. "this will return the proxy which will be already installed"! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/13/2015 12:26'!
restoreAllValues

	self ownerObjectToVarValueDict ifNotNilDo: [ :dict | dict keysAndValuesDo: [ :insObj :value |  self owner: insObj storeValueInVar: value.  ]]! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/13/2015 12:27'!
traceExecuteWithSelector: aSelector arguments: arguments andReturnValue: returnValue forOwner: anObject

	"we end-up here (receiving a message) from a reference inside/propagated from myInstrumentedObject read/writes"

	varTraceFlag ifTrue: [ varTrace addExecuteFrom: thisContext sender sender sender 
											withCurrentValueClass: (self ownerObjectToVarValueDict at: anObject) class  
											withSelector: aSelector 
											argumentClasses: (arguments collect: [:arg | arg class])  
											andReturnValueClass: returnValue class
											forOwner: anObject. ]! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/13/2015 12:28'!
traceReadForOwner: anObject

	varTraceFlag ifTrue: [ varTrace addReadFrom: thisContext sender sender withCurrentValueClass: (self ownerObjectToVarValueDict at: anObject) class forOwner: anObject  ]! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 12:42'!
traceType

	^ varTrace class! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/13/2015 12:28'!
traceWriteWithNewValue: aValue forOwner: anObject

	varTraceFlag ifTrue: [ varTrace addWriteFrom: thisContext sender sender withCurrentValueClass: (self ownerObjectToVarValueDict at: anObject) class  andNewValueClass: aValue class forOwner: anObject ]
! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/13/2015 14:04'!
uninstall

	self varTrace: false. "you don't want"
	self restoreAllValues.
	varSites do: [ :varSite |  varSite ifNotNil: [  varSite uninstallInstrumentation] ].
	ownerObjectToVarValueDict := nil.! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:14'!
varInClass

	^ class! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:34'!
varName

	^ varName! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:34'!
varSites

	^ varSites ! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:35'!
varTrace

	^ varTrace! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/10/2015 10:35'!
varTrace: aBoolean

	varTraceFlag := aBoolean! !

!VariableReference methodsFor: 'rwx' stamp: 'NickPapoulias 9/13/2015 12:43'!
write: aValue forOwner: anObject

	self checkPreExistingValueForOwner: anObject; traceWriteWithNewValue: aValue forOwner: anObject.
	self ownerObjectToVarValueDict at: (self properSideOf: anObject) put: aValue. 
	^ self ownersStoredValue: anObject. "this will return the proxy which will be already installed"! !

Object subclass: #VariableReferenceProxy
	instanceVariableNames: 'instrumentedObject variableReference'
	classVariableNames: 'FastDNUClass'
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VariableReferenceProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 09:58'!
fastDNUClass

	"recompute each time in case smth changed"

	FastDNUClass := Behavior new.
	FastDNUClass setFormat: self format.
	FastDNUClass methodDict: methodDict. "since this is not a deep copy the two classes are in sync ?"
	FastDNUClass superclass: nil.
	^ FastDNUClass.! !

!VariableReferenceProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 09:58'!
new
	
	| newInstance |
	
	newInstance := self basicNew initialize.
	self fastDNUClass adoptInstance: newInstance.
	^ newInstance! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 09:59'!
__instrumentedObject
	^ instrumentedObject! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 09:59'!
__instrumentedObject: anObject
	instrumentedObject := anObject! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:02'!
__isAVariableReferenceProxy

	^ true! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:00'!
__variableReference
	^ variableReference! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:00'!
__variableReference: anObject
	variableReference := anObject! !

!VariableReferenceProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:49'!
doesNotUnderstand: aMessage
			
	^ variableReference execute: aMessage selector withArgs: aMessage arguments forOwner: instrumentedObject from: self.! !

DummyClass initialize!
